Supporting In-Situ Operations, Administration, and Maintenance Direct Export Using MPLS Network Actions
Internet-Draft draft-mb-mpls-ioam-dex-08
Greg Mirsky
Ericsson
gregimirsky@gmail.com
Mohamed Boucadair
Orange
35000 Rennes
France
mohamed.boucadair@orange.com
Tony Li
Juniper Networks
tony.li@tony.li
2024
Routing
MPLS Working Group
Internet-Draft
IOAM
MPLS Network Action
In-Situ Operations, Administration, and Maintenance (IOAM), defined in RFC 9197, is an on-path telemetry method to collect and transport the operational state and telemetry information that can be used to calculate various performance metrics. IOAM Direct Export (IOAM-DEX) is one of the IOAM Option types, in which the operational state and telemetry information are collected according to the specified profile and exported in a manner and format defined by a local policy. MPLS Network Actions (MNA) techniques are meant to indicate actions to be performed on any combination of Label Switched Paths (LSPs), MPLS packets, and the node itself, and also to transfer data needed for these actions. This document explores the on-path operational state, and telemetry information can be collected using IOAM-DEX Option in combination with MNA.
Introduction
In-Situ OAM (IOAM) [RFC9197] is an on-path telemetry method to collect and transport the operational state and telemetry information that can be used to calculate various performance metrics. Several IOAM Option types (e.g., Pre-allocated and Incremental) use the user packet to collect the operational state and telemetry information. Such a mechanism transports the collected information to an IOAM decapsulating node (typically located at the edge of the IOAM domain within the data packet). IOAM Direct Export (IOAM-DEX) [RFC9326] is an IOAM Option type. In IOAM-DEX, the operational state and telemetry information are collected according to the specified profile and exported in a manner and format defined by a local policy. MPLS Network Actions (MNA) techniques [I-D.ietf-mpls-mna-fwk] indicate actions to be performed on any combination of Label Switched Paths (LSPs), MPLS packets, the node itself, and also allow for the transfer of data needed for these actions.
This document describes how MNA can be used for collecting on-path operational state and telemetry information using IOAM-DEX Option. Specifying the mechanism of exporting collected information is outside the scope of this document.
Conventions Used in this Document

Acronyms
IOAM: In-Situ OAM
IOAM-DEX: IOAM Direct Export
IOAM-DEX-MNA: IOAM Direct Export in MPLS Network Action
ISD: In-Stack Data
LSP: Label Switched Path
LSE: Label Stack Entry
MPLS: Multiprotocol Label Switching
MNA: MPLS Network Action
NAI: Network Action Indicator
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Applicability of IOAM Option Types in an MPLS Network
Pre-allocated, Incremental, and Edge-to-Edge IOAM Option types [RFC9197] use user packets to collect and transport the operational state and telemetry information. In some environments, for example, data center networks, this technique is useful as the available bandwidth and the use of jumbo frames can accommodate the increase of the packet payload. But for other use cases in which network resources are closely controlled, the use of in-band channels for collecting and transporting the telemetry information may noticeably decrease the cost-efficiency of network operations. Although the operational state and telemetry information are essential for network automation (Section 4 of [RFC8969]), its delivery is not as critical as user packets. As such, collecting and transporting the operational state and telemetry information out-of-band using the management plane is a viable option for some environments. IOAM-DEX [RFC9326] is used to collect IOAM data defined in [RFC9197]. The processing and transport of the collected information are controlled by a local policy which is outside the scope of this specification. The performance considerations discussed in Section 5 of [RFC9326] are applicable here.
Realization of IOAM-DEX as an MPLS Network Action
IOAM-DEX Format for an MPLS Network
[I-D.ietf-mpls-mna-usecases] recognizes the importance of IOAM in MPLS networks and lists it as one of the use cases that might be supported using MNA techniques. [I-D.ietf-mpls-mna-fwk] defines the architectural elements that compose MNA. This document uses all the elements of the IOAM-DEX Option-Type format defined in [RFC9326] to support IOAM-DEX in an MPLS network using MPLS Network Action (MNA) framework [I-D.ietf-mpls-mna-fwk] and architecture as in-stack data (ISD) MNA [I-D.ietf-mpls-mna-hdr]. The IOAM-DEX in MNA header is using LSE Format D, as defined in Section 4.4 [I-D.ietf-mpls-mna-hdr] mapping IOAM-DEX Optin Type format [RFC9326]. In addition to the requirement to preserve the Bottom of Stack field, the most significant bit in LSE Format D is always set to 1 avoiding a possible mix-up of the LSE with one of the Base Special Purpose Labels. The format of IOAM-DEX in MNA is shown in Figure 1.
IOAM Direct Export Option Type Format in an MPLS Network Action Framework

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|1|         Namespace-ID          |    Resv   |S|     Flags     |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|1|            IOAM-Trace-Type-MNA            |S|O|R| Ext-Flags |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|1|           Flow ID MNA (Optional)          |S| Flow ID MNA   |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|1|       Sequence Number MNA (Optional)      |S|  Seq Num MNA  |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Where fields are defined as follows:
- Namespace-ID is a 16-bit identifier of the IOAM Namespace, as defined in [RFC9197].
- S is a one-bit the Bottom of Stack [RFC3032].
- Flags is an eight-bit field comprised of eight one-bit subfields. The subfields in the Flags field are allocated by IANA in IOAM DEX Flags registry, as defined in Section 4.2 of [RFC9326].
- IOAM-Trace-Type-MNA is a 22-bit field. The interpretation of bit positions in the IOAM-Trace-Type-MNA is as specified in IANA's IOAM Trace-Type registry [IANA-IOAM-Trace-Type] from Bit 0 through Bit 21.
- O is the one-bit flag identical to the interpretation of Bit 22 variable-length Opaque State Snapshot in IANA's IOAM Trace-Type registry [IANA-IOAM-Trace-Type].
- R (Reserved) is a one-bit flag identical to the interpretation of Bit 23 in IANA's IOAM Trace-Type registry [IANA-IOAM-Trace-Type]. It MUST be zeroed on the transmission and ignored on receipt. Similarly to [RFC9197], it is reserved to allow for future extensions of the IOAM-Trace-Type-MNA bit field.
- The concatenation of IOAM-Trace-Type-MNA, O, and R fields, explained above, is identical to IOAM-Trace-Type in the interpretation of its bits, assigned in IANA's IOAM Trace-Type registry [IANA-IOAM-Trace-Type]. Also, note that the Bit 7 field, i.e., checksum complement, is handled as defined in [RFC9326].
- Ext-Flags is a six-bit field comprised of six one-bit subfields. The allocation of the subfields in the Ext-Flags field is according to Section 4.3 of [RFC9326]. The allocated flags indicate the presence of the optional Flow ID and/or Sequence Number fields in the IOAM-DEX-MNA header. The length of the Ext-Flags field in IOAM-DEX Option-Type in MNA is shorter by two one-bit fields compared to the length of the Extension Flags field defined in Section 3.2 of [RFC9326]. Mapping of these two bit positins is for further study. Figure 2 displays the detailed format of the Ext-Flags field.
- Optional fields, i.e., Flow ID and Sequence Number, according to [RFC9326], immediately follow the Reserved field used to align optional fields at the four-octet word boundary. In the case of IOAM-DEX in MNA, such alignment can be achieved without using padding.
- Flow ID MNA is an optional 30-bit field. The semantics of the Flow ID MNA field is as of the Flow ID field defined in Section 3.2 of [RFC9326].
- Sequence Number MNA - is an optional 30-bit field. The semantics of the Sequence Number MNA field is as of the Sequence Number field defined in Section 3.2 of [RFC9326]. In MPLS network environments where a label stack information is used for load-balancing flows, the 19-bit-long part of the Sequence Number MNA, starting from the Bit 1 position of the LSE, MUST remain immutable for a particular packet flow that the value of the Flow ID MNA field identifies. In MPLS networks, where other load-balancing techniques are used, all 30 bits of the Sequence Number MNA field can be variated. Although the length of the Sequence Number field in IOAM-DEX in MNA is smaller than the 32-bit length allotted in [RFC9326], there is sufficient space before the rollover so that its value, in combination with the value of the Flow ID field, can be used to correlate the exported data generated by the same trigger packet carrying IOAM-DEX MNA.
Ext-Flags Field Format

 0 1 2 3 4 5
+-+-+-+-+-+-+
|F|S|U|U|U|U|
+-+-+-+-+-+-+

Where fields are defined as follows:
- F - one-bit flag. When the flag is set to 1, it indicates the presence of the Flow ID field in the IOAM-DEX-MNA header.
- S - one-bit flag. When the flag is set to 1, it indicates the presence of the Sequence Number field in the IOAM-DEX-MNA header.
- U - unassigned one-bit flag. It MUST be zeroed on transmission and the value MUST be ignored upon receipt.
IOAM-DEX-MNA Encoding as In-Stack Data MPLS Network Action
To support the direct export of the operational state and telemetry information, the IOAM-DEX-MNA blob (binary large object), as shown in Figure 1 can be placed as part of the ISD block in an MPLS label stack according to the MNA encoding principles defined in [I-D.ietf-mpls-mna-hdr]. Using the IHS field, the IOAM-DEX-MNA can be performed in Hop-by-Hop, Ingress-to-Egress, or Select modes [I-D.ietf-mpls-mna-fwk] of collecting the operational state and telemetry information, as MNA Opcode (Figure 3). Policies controlling the processing of the collected operational state and telemetry information, and its transport are outside the scope of this document.
An Example of IOAM-DEX Encapsulation as an MNA Opcode

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|               MNA bSPL                | TC  |S|    TTL        |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
| Opcode = TBA1 |        Data           |P|IHS|S| Res |U|  NASL |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
~                         IOAM-DEX-MNA                          ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Where the enclosed elements are defined as follows:
- MNA bSPL is a base Special Purpose Label assigned by IANA per the request in [I-D.ietf-mpls-mna-hdr].
- S - the Bottom of Stack field [RFC3032].
- P, IHS, Res, U, and NASL fields are as specified in Section 4.2 of [I-D.ietf-mpls-mna-hdr].
- NASL - number of LSEs that compose the IOAM-DEX-MNA blob.
- Opcode is MNA-IOAM-DEX opcode (TBA1) assigned by IANA Section 5.1.
- IOAM-DEX-MNA - IOAM Direct Export in MPLS Network Action encoding
IANA Considerations
IOAM-DEX-MNA as an MPLS Network Action Opcode
IANA is requested to assign an IOAM-DEX-MNA codepoint (TBA1) from its Network Action Opcodes registry (creation requested in [I-D.ietf-mpls-mna-hdr]) as specified in Table 1.
IOAM-DEX as MPLS Network Action Opcode
Opcode | Description | Reference
TBA1 | IOAM-DEX as MPLS Network Action Indicator | This document
Security Considerations
Security considerations discussed in [RFC9197], [RFC9326], and [I-D.ietf-mpls-mna-fwk] apply to this document.
Acknowledgments
The authors exxpress their sincereappreciation to Loa Andersson for his thorough review and thoughtful suggestion that helped in improving this document.
References
Normative References
Informational References
[IANA-IOAM-Trace-Type]

IOAM Trace-Type
IANA
[RFC9197]
[RFC9326]
[I-D.ietf-mpls-mna-fwk]
[RFC2119]
[RFC8174]
[RFC8969]
[I-D.ietf-mpls-mna-usecases]
[I-D.ietf-mpls-mna-hdr]
[RFC3032]